﻿var 图片验证码 = (function (_super) {
    __extends(图片验证码, _super);
    function 图片验证码() {
        return _super !== null && _super.apply(this, arguments) || this;
    }

    图片验证码.prototype._verifyCode = null;

    图片验证码.prototype.createContent = function () {
        var self = this;
        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var container = $("<div id='" + this.ID + "'></div>");
        this.onDependenceCellValueChanged(function () {
            self.validate();
        });
        
        return container;
    };

    图片验证码.prototype.onLoad = function () {
        var self = this;
        this.createCode();
        // 点击验证码canvas时刷新验证码并验证
        document.getElementById(this.ID).onclick = function () {
            var inputVerifyCode = self.CellElement.CellType.InputVerifyCode;
            Forguncy.Page.getCellByLocation(Forguncy.FormulaHelper.getCellLocation(inputVerifyCode, "p")).setValue("");
            self.validate();
        }
    }

    // 创建canvas验证码
    图片验证码.prototype.createCode = function () {
        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var type = "";
        if (cellTypeMetaData.CodeTypes == CodeType.Blend) {
            var verifyCode = new GVerify(
                {
                    id: this.ID,
                    type: "blend",
                    width: element.Width,
                    height: element.Height
                });
        } else if (cellTypeMetaData.CodeTypes == CodeType.Number) {
            var verifyCode = new GVerify(
                {
                    id: this.ID,
                    type: "number",
                    width: element.Width,
                    height: element.Height
                });
        } else {
            var verifyCode = new GVerify(
                {
                    id: this.ID,
                    type: "letter",
                    width: element.Width,
                    height: element.Height
                });
        }
        _verifyCode = verifyCode;
        verifyCode.refresh();
    }

    图片验证码.prototype.getValueFromElement = function () {
        return null;
    };

    图片验证码.prototype.setValueToElement = function (element, value) {

    };

    图片验证码.prototype.disable = function () {
        _super.prototype.disable.call(this);
    };

    图片验证码.prototype.enable = function () {
        _super.prototype.enable.call(this);
    };

    // 验证验证码结果
    图片验证码.prototype.validate = function () {
        var self = this;
        var element = this.CellElement;
        var cellTypeMetaData = element.CellType;
        var inputCode = self.evaluateFormula(cellTypeMetaData.InputVerifyCode);
        var verifyResultCell = cellTypeMetaData.VerifyResultCell;
        var inputVerifyCode = cellTypeMetaData.InputVerifyCode;
        if (inputCode !== null && _verifyCode.validate(inputCode)) {
            Forguncy.Page.getCellByLocation(Forguncy.FormulaHelper.getCellLocation(verifyResultCell, "p")).setValue(1);
        } else {
            Forguncy.Page.getCellByLocation(Forguncy.FormulaHelper.getCellLocation(verifyResultCell, "p")).setValue(0);
            // 输入验证码单元格置空
            Forguncy.Page.getCellByLocation(Forguncy.FormulaHelper.getCellLocation(inputVerifyCode, "p")).setValue("");
            _verifyCode.refresh();
        }
    }

    return 图片验证码;
}(Forguncy.CellTypeBase));

var CodeType = {
    Blend: 0,
    Number: 1,
    Letter: 2
}

// Key format is "Namespace.ClassName, AssemblyName"
Forguncy.Plugin.CellTypeHelper.registerCellType("图片验证码.图片验证码, 图片验证码", 图片验证码);